/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <device.h>

#define DMA_0_BYTES_PER_BURST 2
#define DMA_0_REQUEST_PER_BURST 1
#define DMA_0_SRC_BASE (CYDEV_PERIPH_BASE)
#define DMA_0_DST_BASE (CYDEV_SRAM_BASE)

uint8 DMA_0_Chan;
uint8 DMA_0_TD[2];

CY_ISR(fifoFull){
}

CY_ISR(fifoInt){
}

void init_DMA0(void){
	DMA_0_Chan = DMA_0_DmaInitialize(DMA_0_BYTES_PER_BURST, DMA_0_REQUEST_PER_BURST, 
	    HI16(DMA_0_SRC_BASE), HI16(DMA_0_DST_BASE));
	DMA_0_TD[0] = CyDmaTdAllocate();
	DMA_0_TD[1] = CyDmaTdAllocate();
	CyDmaTdSetConfiguration(DMA_0_TD[0], 40, DMA_0_TD[1], TD_INC_DST_ADR | TD_AUTO_EXEC_NEXT);
	CyDmaTdSetConfiguration(DMA_0_TD[1], 12, DMA_0_TD[1], TD_INC_DST_ADR | TD_AUTO_EXEC_NEXT);
	CyDmaTdSetAddress(DMA_0_TD[0], LO16((uint32)FIFOIn_1_FIFO16_PTR), LO16((uint32)0x20000000));
	CyDmaTdSetAddress(DMA_0_TD[1], LO16((uint32)FIFOIn_1_FIFO16_PTR), LO16((uint32)0x2000002A));
	CyDmaChSetInitialTd(DMA_0_Chan, DMA_0_TD[0]);
	CyDmaChEnable(DMA_0_Chan, 1);
}

void main(){

	VDAC8_0_Start();
	VDAC8_1_Start();
	
	init_DMA0();
	
	FIFOIn_1_Start();
	
	isr_1_StartEx(fifoFull);
	isr_2_StartEx(fifoInt);

    CyGlobalIntEnable; /* Uncomment this line to enable global interrupts. */
    for(;;)
    {
        /* Place your application code here. */
    }
}

/* [] END OF FILE */
